GDAL

Classes | Typedefs | Enumerations | Functions
gdalpansharpen.h File Reference

GDAL pansharpening related entry points and definitions. More...

`#include "gdal.h"`
`#include <array>`
`#include <vector>`
`#include "gdal_priv.h"`

Go to the source code of this file.

## Classes
struct | GDALPansharpenOptions
| Pansharpening options. More...
class | GDALPansharpenOperation
| Pansharpening operation class. More...

## Typedefs
typedef void * | GDALPansharpenOperationH

## Enumerations
enum | GDALPansharpenAlg { GDAL_PSH_WEIGHTED_BROVEY }
| Pansharpening algorithms. More...

## Functions
GDALPansharpenOptions * | GDALCreatePansharpenOptions (void)
| Create pansharpening options.
void | GDALDestroyPansharpenOptions (GDALPansharpenOptions *)
| Destroy pansharpening options.
GDALPansharpenOptions * | GDALClonePansharpenOptions (const GDALPansharpenOptions *psOptions)
| Clone pansharpening options.
GDALPansharpenOperationH | GDALCreatePansharpenOperation (const GDALPansharpenOptions *)
| Instantiate a pansharpening operation.
void | GDALDestroyPansharpenOperation (GDALPansharpenOperationH)
| Destroy a pansharpening operation.
CPLErr | GDALPansharpenProcessRegion (GDALPansharpenOperationH hOperation, int nXOff, int nYOff, int nXSize, int nYSize, void *pDataBuf, GDALDataType eBufDataType)
| Executes a pansharpening operation on a rectangular region of the resulting dataset.

## Detailed Description

GDAL pansharpening related entry points and definitions.

Since
  GDAL 2.1

## Typedef Documentation

## ◆ GDALPansharpenOperationH

typedef void* GDALPansharpenOperationH

Pansharpening operation handle.

## Enumeration Type Documentation

## ◆ GDALPansharpenAlg

enum GDALPansharpenAlg

Pansharpening algorithms.

Enumerator
GDAL_PSH_WEIGHTED_BROVEY | Weighted Brovery.

## Function Documentation

## ◆ GDALClonePansharpenOptions()

GDALPansharpenOptions * GDALClonePansharpenOptions | ( | const GDALPansharpenOptions * | psOptions | ) |

Clone pansharpening options.

Parameters

  psOptions | a pansharpening option structure allocated with GDALCreatePansharpenOptions()

Returns
  a newly allocated pansharpening option structure that must be freed with GDALDestroyPansharpenOptions().

Since
  GDAL 2.1

## ◆ GDALCreatePansharpenOperation()

GDALPansharpenOperationH GDALCreatePansharpenOperation | ( | const GDALPansharpenOptions * | psOptions | ) |

Instantiate a pansharpening operation.

The passed options are validated.

Parameters

  psOptions | a pansharpening option structure allocated with GDALCreatePansharpenOptions(). It is duplicated by this function.

Returns
  a valid pansharpening operation handle, or NULL in case of failure.

Since
  GDAL 2.1

## ◆ GDALCreatePansharpenOptions()

GDALPansharpenOptions * GDALCreatePansharpenOptions | ( | void |  | ) |

Create pansharpening options.

Returns
  a newly allocated pansharpening option structure that must be freed with GDALDestroyPansharpenOptions().

Since
  GDAL 2.1

## ◆ GDALDestroyPansharpenOperation()

void GDALDestroyPansharpenOperation | ( | GDALPansharpenOperationH | hOperation | ) |

Destroy a pansharpening operation.

Parameters

  hOperation | a valid pansharpening operation.

Since
  GDAL 2.1

## ◆ GDALDestroyPansharpenOptions()

void GDALDestroyPansharpenOptions | ( | GDALPansharpenOptions * | psOptions | ) |

Destroy pansharpening options.

Parameters

  psOptions | a pansharpening option structure allocated with GDALCreatePansharpenOptions()

Since
  GDAL 2.1

## ◆ GDALPansharpenProcessRegion()

CPLErr GDALPansharpenProcessRegion | ( | GDALPansharpenOperationH | hOperation,
|  | int | nXOff,
|  | int | nYOff,
|  | int | nXSize,
|  | int | nYSize,
|  | void * | pDataBuf,
|  | GDALDataType | eBufDataType
| ) |  |

Executes a pansharpening operation on a rectangular region of the resulting dataset.

The window is expressed with respect to the dimensions of the panchromatic band.

Spectral bands are upsampled and merged with the panchromatic band according to the select algorithm and options.

Parameters

  hOperation | a valid pansharpening operation.
  nXOff | pixel offset.
  nYOff | pixel offset.
  nXSize | width of the pansharpened region to compute.
  nYSize | height of the pansharpened region to compute.
  pDataBuf | output buffer. Must be nXSize * nYSize * GDALGetDataTypeSizeBytes(eBufDataType) * psOptions->nOutPansharpenedBands large. It begins with all values of the first output band, followed by values of the second output band, etc...
  eBufDataType | data type of the output buffer

Returns
  CE_None in case of success, CE_Failure in case of failure.

Since
  GDAL 2.1